# coding: utf-8
"""

"""

from __future__ import unicode_literals

import base64
from hashlib import md5


def encode_file(filename):
    """Encode a file

    :param filename: file to be encoded
    :return: a tuple: encoded_data, md5 
    """
    encoded_data = base64.b64encode(open(filename, 'rb').read())
    emmedic = md5(open(filename, 'rb').read()).hexdigest()
    return encoded_data, emmedic


def open_and_get_md5(filename):
    """
    :param filename: file to be opened
    :return: a tuple: opened_file, md5
    """
    with open(filename, 'rb') as _file:
        _file = _file.read()
        emmedic = md5(_file).hexdigest()
        return _file, emmedic


def decode_file(encoded_image, output_path=None):
    """Decode a file

    :param encoded_image: string holding a base64 encoded image
    :param output_path: path of file to be written
    :return: the decoded file or write it to output_path
    """
    content = base64.b64decode(encoded_image)
    if output_path:
        f = open(output_path, 'wb')
        f.write(content)
        f.close()
    else:
        return content


def get_and_save_image(image, output_path=None):
    """
    :param image: bytes
    :param output_path: path of file to be written
    :return: the decoded file or write it to output_path
    """
    if output_path:
        f = open(output_path, 'wb')
        f.write(image)
        f.close()
    else:
        return image
